unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Types3D,
  FMX.Materials, FMX.Objects3D;

type
  TForm1 = class(TForm3D)
    Light1: TLight;
    Sphere1: TSphere;
    Cube1: TCube;
    LightMaterialSource1: TLightMaterialSource;
    LightMaterialSource2: TLightMaterialSource;
    Camera1: TCamera;
    Sphere2: TSphere;
    procedure Form3DMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; var Handled: Boolean);
    procedure Form3DMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Single);
    procedure Form3DMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Form3DMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single);
    procedure Sphere1MouseEnter(Sender: TObject);
    procedure Sphere1MouseLeave(Sender: TObject);
    procedure Form3DShow(Sender: TObject);
    procedure Sphere1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single; RayPos, RayDir: TVector3D);
    procedure Cube1MouseEnter(Sender: TObject);
    procedure Cube1MouseLeave(Sender: TObject);
    procedure Cube1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Single; RayPos, RayDir: TVector3D);
  private
    { private 錾 }
    MouseOnFlag : Boolean ;
    MouseOnX , MouseOnY : Single ;
  public
    { public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

// N
procedure TForm1.Form3DShow(Sender: TObject);
begin
   MouseOnFlag := False ;
end;

procedure TForm1.Form3DMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   MouseOnFlag := True ;
   MouseOnX := X ;
   MouseOnY := Y ;
end;

procedure TForm1.Form3DMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Single);
var
   dx,dy : Single ;
begin
   Form1.Caption := '}EXʒuF('+FloatToStr(X)+','+FloatToStr(Y)+')' ;
   if (MouseOnFlag) then begin
      if (X < 0)or(Y < 0) then
         MouseOnFlag := False
      else begin
         // }EXhbO
         dx := (X - MouseOnX) ;
         dy :=-(Y - MouseOnY) ;
         Camera1.RotationAngle.Y := dx ;
         Camera1.RotationAngle.X := dy ;
      end;
   end;
end;

procedure TForm1.Form3DMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single);
begin
   MouseOnFlag := False ;
end;

procedure TForm1.Form3DMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; var Handled: Boolean);
begin
   MouseOnFlag := False ;
   Camera1.RotationAngle.X := 0 ;
   Camera1.RotationAngle.Y := 0 ;
   if (WheelDelta > 0) then begin
      // }EXzC[։
      Camera1.Position.Z := Camera1.Position.Z + 1.0 ;
   end
   else if (WheelDelta < 0) then begin
      // }EXzC[։
      Camera1.Position.Z := Camera1.Position.Z - 1.0 ;
   end;
end;

procedure TForm1.Sphere1MouseEnter(Sender: TObject);
begin
   LightMaterialSource1.Diffuse := $FFFF0000 ;  // ԐFɕϐF
   SPhere1.Repaint ;
end;

procedure TForm1.Sphere1MouseLeave(Sender: TObject);
begin
   LightMaterialSource1.Diffuse := TAlphaColorRec.Springgreen ;  // ̗ΐFɖ߂
   SPhere1.Repaint ;
end;

procedure TForm1.Cube1MouseEnter(Sender: TObject);
begin
   LightMaterialSource2.Diffuse := $FFFF0000 ;  // ԐFɕϐF
   SPhere1.Repaint ;
end;

procedure TForm1.Cube1MouseLeave(Sender: TObject);
begin
   LightMaterialSource2.Diffuse := TAlphaColorRec.Aqua ;  // ̐Fɖ߂
   SPhere1.Repaint ;
end;

procedure TForm1.Sphere1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single; RayPos, RayDir: TVector3D);
var
   d : single ;
begin
   {
   ShowMessage('X,Y:'+FloatToStr(X)+','+FloatToStr(Y)+#13+#10
            +  'RayPos.X:'+FloatToStr(RayPos.X)+#13+#10
            +  'RayPos.Y:'+FloatToStr(RayPos.Y)+#13+#10
            +  'RayPos.Z:'+FloatToStr(RayPos.Z)+#13+#10
            +  'RayPos.W:'+FloatToStr(RayPos.W)+#13+#10
            +  'RayDir.X:'+FloatToStr(RayDir.X)+#13+#10
            +  'RayDir.Y:'+FloatToStr(RayDir.Y)+#13+#10
            +  'RayDir.Z:'+FloatToStr(RayDir.Z)+#13+#10
            +  'RayDir.W:'+FloatToStr(RayDir.W)+#13+#10);
   Sphere2.Position.X := Camera1.Position.X + RayDir.X ;
   Sphere2.Position.Y := Camera1.Position.Y + RayDir.Y ;
   Sphere2.Position.Z := Camera1.Position.Z + RayDir.Z ;
   }
   // L͋ʏ̓_ł͂܂@܂łAoEglł
   d := Sqrt(RayPos.X*RayPos.X + RayPos.Y*RayPos.Y + RayPos.Z*RayPos.Z);
   d := d - 2.5 ;
   Sphere2.Position.X := Camera1.Position.X + d * RayDir.X ;
   Sphere2.Position.Y := Camera1.Position.Y + d * RayDir.Y ;
   Sphere2.Position.Z := Camera1.Position.Z + d * RayDir.Z ;
end;

procedure TForm1.Cube1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Single; RayPos, RayDir: TVector3D);
var
   d,cx,cy : single ;
begin
   // ̂NbN
   d := Sqrt(RayPos.X*RayPos.X + RayPos.Y*RayPos.Y + RayPos.Z*RayPos.Z);
   d := d - 2.5 ;
   cx := Camera1.Position.X + d * RayDir.X ;
   cy := Camera1.Position.Y + d * RayDir.Y ;

   if ((cx-Cube1.Position.X) > 1.5) then
      Cube1.Position.X := Cube1.Position.X + 1.0
   else if ((cx-Cube1.Position.X) < -1.5) then
      Cube1.Position.X := Cube1.Position.X - 1.0 ;

   if ((cy-Cube1.Position.Y) > 1.5) then
      Cube1.Position.Y := Cube1.Position.Y + 1.0
   else if ((cy-Cube1.Position.Y) < -1.5) then
      Cube1.Position.Y := Cube1.Position.Y - 1.0 ;
end;

end.
